<?php defined('_JEXEC') or die('Restricted access');

/**
 * $Revision: 1.4 $
 */
class JCommentInstallHelper {
	
	/**
	 * Liefert true, wenn JComment installiert ist.
	 *
	 * @return true, wenn JComment installiert ist, ansonsten false
	 */
	public static function isJCommentInstalled(){
		jimport( 'joomla.application.component.helper' );
		$component = JComponentHelper::getComponent('com_jcomments',true);
		if ($component->enabled){
			return true;
		}
		return false;
	}
	
	/**
	 * Liefert true, wenn das  H2N Link Directory 2 Plugin für JComment installiert ist.
	 *
	 * @return true, wenn das  H2N Link Directory 2 Plugin für JComment installiert ist, ansonsten false
	 */
	public static function isLinkdirectoy2PluginInstalled(){
		if (self::isJCommentInstalled()){
			global $option;				
			$comments = JPATH_SITE . DS.'components'.DS.'com_jcomments'.DS.'jcomments.php';
		  	if (file_exists($comments) && file_exists(JPATH_SITE .DS.'components'.DS.'com_jcomments'.DS.'plugins'.DS.$option.'.plugin.php')) {		    	
		    	return true;
		  	}
		}
		return false;
	}
	
	/**
	 * Kopiert das H2N Link Directory 2 Plugin für JComment in das JComment-Plugin-Verzeichnis. Wenn es 
	 * schon vorhanden ist, wird es überschrieben.
	 *
	 * @return true, wenn schon vorhanden oder das Kopieren geklappt hat. Bei Fehlern 
	 *               wird JError mit der Priorität E_WARNING zurückgegeben.
	 */
	public static function installLinkdirectory2Plugin(){
		if (self::isJCommentInstalled()){
			$src=JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_linkdirectory2'.DS.'com_linkdirectory2.plugin.php';
			$dest=JPATH_SITE.DS.'components'.DS.'com_jcomments'.DS.'plugins'.DS.'com_linkdirectory2.plugin.php';
			
			jimport('joomla.filesystem.folder');
			if (!JFolder::exists(dirname($dest))){
			 	return JError::raiseWarning(-1, JText::sprintf('Can not find destination directory [%s]',dirname($dest)));
			}
			
			jimport('joomla.filesystem.file');
			if (JFile::exists($src)){
				return JFile::copy($src,$dest);
			} else {
				return JError::raiseWarning(-1, JText::sprintf('Can not find source file [%s]',$src));
			}
		} else {
			  return JError::raiseWarning(-1, JText::_('JComment is not installed'));	
		}
	}
}
?>