<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: webcategory.php,v 1.2 2009-09-29 19:20:52 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

class TableWebcategory extends JTable {
	
	public $id = null;
	public $parent_id = null;
	public $title = null;
	public $name = null;
	public $image = null;
	public $description = null;
	public $published = null;
	public $checked_out = null;
	public $checked_out_time = null;
	public $editor = null;
	public $ordering = null;
	public $access = null;
	public $count = null;
	public $params = null;
		
	public function __construct(& $db) {
		parent::__construct('#__ldcats', 'id', $db);
	}

	/**
	 * Überprüft zusätzlich, ob published konsitent zum ELtern bzw. Kind-Elemeneten ist. Wird eine Inkonstenz festgestellt,
	 * so wird publish auf den ürsprünglichen Wert gesetzt und eine Meldung mit setError gesetzt. 
	 *
	 * @param unknown_type $updateNulls
	 * @return true, wenn das Schreiben geklappt hat, sonst false
	 */
	public function store( $updateNulls=false ){
		$fixResult = $this->fixPublished();
		$result = parent::store($updateNulls);
		if ($fixResult){
			$this->setError(JText::sprintf('Can not change published for item.',$this->name));
		}
		return $result;
	}
	
	/**
	 * Passt published so an, dass die Kategorie konsistent zu ihrem Parent bzw. zu ihren Kindern konsistent ist.
	 * Erfolgt eine Anpassung, wird true zurückgelifert, ansonsten false.
	 *
	 * @return true, wenn eine Anpassung erfolgt ist, sonst false.
	 */
	
	private function fixPublished(){
		if ($this->published){
			if ($this->parent_id != 0 ) {
				$this->_db->setQuery( "SELECT count(*) FROM #__ldcats WHERE id =  $this->parent_id AND published = 1");
				if ( intval($this->_db->loadResult()) == 0 ){
					$this->published = 0;
					return true;
				}
			}
		} else {
			$this->_db->setQuery( "SELECT count(*) FROM #__ldcats WHERE parent_id =  $this->id AND published = 1");
			if ( intval($this->_db->loadResult()) != 0 ){
				$this->published = 1;
				return true;
			}
		}
		return false;
	}
}
